#include <stdio.h>
#include <stdlib.h>

#include "tokenizer.h"




// we don't expect other programmers to use tokens_add directly, therefore its prototype is here and not in tokenizer.h
void tokens_add(char** tokens, int nbmaxtokens, char* user_input, int start, int stop); 


void tokenize(char** tokens, int maxnbtokens, char * str, int length)
// Synopsis: 	parses the string str and make a copy in newly allocated strings of all 
//		the words it contains. The address of these copies are inserted in the tokens array
//		of pointers using the tokens_add function. 
// Parameters: 
//		tokens 		dynamical array of strings (char*)
//				each will point to a copy of a token from the str string
//		maxnbtokens	size of the tokens array 
//				in tokens, unused pointers are simply NULL
//		str		string from which we need to extract tokens
//		length		length of the str string we could do without this parameter 
//				but since the information is readily available in the main
//				why not using it? 
{
		
	// we use #ifdef / #endif to display debugging information only if the #define DEBUG_MODE line 
	// has been uncommented in tokenizer.h when compiling this project
	// This is a very common trick
	#ifdef DEBUG_MODE
	printf("\tTokenizing: %s\n", str); 
	#endif
	
	// TODO: write here the part of the function which will go through the str string and stop each time a full word 
	// has been encountered. You can detect the end of a word when you encounter '\n', ' ', '\t' or even '\0'
	// once you know that you just reached the end of a word, you have the index of its last character. If you are 
	// careful about storing the index of its first character in a int variable as well, then you are now capable 
	// to extract all the characters of the word. To do so, you can use the tokens_add function
	// 			tokens_add(tokens, maxnbtokens, str, start, stop);
	// keep doing this until you reach '\0' in str.
}



void tokens_display(char** tokens, int maxnbtokens)
// Synopsis: 	iterates over all non-NULL pointers in the tokens array and display information about each token
// Parameters: 
//		tokens 		dynamical array of strings (char*)
//				each will point to a copy of a token from the string parsed by tokenize
//		maxnbtokens	size of the tokens array 
//				in tokens, unused pointers are simply NULL
{
	printf("\tIdentified Tokens:\n"); 
	int i; 
	for(i=0 ; i < maxnbtokens ; i++)
		if (tokens[i] != NULL)
			printf("\tTokens[%d] \t= [%s]\n", i, tokens[i]); 
		else
			break; 
}



char** tokens_allocate(int maxnbtokens)
// Synopsis: 	allocates a dynamical array of maxnbtokens pointers (char*)
// Parameters: 
//		maxnbtokens	size of the tokens array
{
	// TODO: let's allocate the data structure to contain all our tokens copies
		
	
	// TODO: we have now an array holding n pointers on strings
	// each time we discover a new token we will allocate a string 
	// to hold a copy of it and put its address at the next available 
	// pointer in strings_array. To make it easy to identify which pointer(s)
	// are free, we will set them all to NULL initially
	
	// TODO: return our dynamically allocated array
}

void tokens_deallocate(char** tokens, int maxnbtokens)
// Synopsis: 	deallocates the dynamical array tokens of maxnbtokens pointers
// Parameters: 
//		tokens		pointer on dynamical array of strings (char*)
//		maxnbtokens	size of the tokens array
{
	#ifdef DEBUG_MODE
	printf("\tDeallocating tokens...\n"); fflush(stdout); 
	#endif 
	
	// TODO: let's start by deallocating all pointers to strings in tokens
	
	// TODO: then we can deallocate the dynamical array of pointers
	
	
	#ifdef DEBUG_MODE
	printf("\tDONE deallocating tokens\n"); fflush(stdout);
	#endif
}


void tokens_add(char** tokens, int maxnbtokens, 
		char* user_input, 
		int start, int stop)
// Synopsis: 	makes a copy of the token starting at index start and ending at index stop in the string user_input
//		this copy is stored in a newly allocated string and a '\0' is added at its end
//		we then locate the next NULL pointer available in tokens (watch for the limit maxnbtokens though)
//		and assign to it the address of our token copy
// Parameters: 
//		tokens		pointer on dynamical array of strings (char*)
//		maxnbtokens	size of the tokens array
//		user_input	string from which we will extract our token
//		start		index of the first character of our token
//		stop 		index of the last character of our token
{
	// TODO: look for the first unused pointer in tokens
	
	
	// TODO: make sure tokens is not already full 
	
	// TODO: measure the length of the token we found in user_input
	
	// TODO: allocating a dynamical string to hold this token's copy
	
	
	// TODO: make a copy of the token we found in the user_input string
	// we copy all the characters between start and stop (both inclusive)
	// use strncpy to do that 
	
	// TODO: add a '\0' to make sure our newly created strings is properly formatted
	
	// TODO: add this new string to tokens

}
